/*
 * Copyright (c) 1997-1998 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */
/*
 * Default implementation of _exit().
 * Since we can't assume anything about our environment,
 * the only reasonable thing to do is simply
 * to print a message and loop forever.
 */

#include <stdio.h>
#include <unistd.h>

static void 
loop_infinitely(int code)
{
	printf("Exited with return code %d.\nLooping forever...\n", code);
	while (1);
}

void (*oskit_libc_exit)(int) = loop_infinitely;

void _exit(int code)
{
	oskit_libc_exit(code);
}

