#include <oskit/types.h>

#ifdef	NATIVE_BUILD
#define NATIVEOS(x)	native_##x
#else
#define NATIVEOS(x)	x
#endif


#ifdef	NEEDBSDTYPES
/*
 * Define BSD style types.
 */
typedef	oskit_s32_t	int32_t;
typedef	oskit_s64_t	int64_t;
typedef	oskit_u32_t	u_int32_t;
typedef	oskit_u16_t	u_int16_t;
typedef	oskit_u8_t	u_int8_t;
typedef	oskit_u8_t	u_char;
typedef	oskit_u16_t	u_short;
typedef	oskit_u32_t	u_int;
typedef	oskit_u32_t	u_long;
typedef	oskit_s8_t *	caddr_t;

/*
 * Structure defined by POSIX.4 to be like a timeval.
 */
struct timespec {
        time_t  tv_sec;         /* seconds */
        long    tv_nsec;        /* and nanoseconds */
};
#endif


#ifdef NATIVE_BUILD
int		NATIVEOS(close)(int);
int		NATIVEOS(stat)();
int		NATIVEOS(mkdir)();
int		NATIVEOS(stat)();
int		NATIVEOS(chmod)();
int		NATIVEOS(chown)();
int		NATIVEOS(access)();
int		NATIVEOS(readlink)();
int		NATIVEOS(fsync)();
int		NATIVEOS(mkdir)();
int		NATIVEOS(rmdir)();
int		NATIVEOS(read)();
int		NATIVEOS(write)();
int		NATIVEOS(open)();
int		NATIVEOS(unlink)();
int		NATIVEOS(link)();
oskit_u64_t	NATIVEOS(lseek)(int, oskit_u64_t, int);
int		NATIVEOS(symlink)();
int		NATIVEOS(getdirentries)();
int		NATIVEOS(truncate)(char *, int, oskit_u64_t);
#endif
