/*
 * @COPYRIGHT@
 *
 * Scout Version 1.0
 * 
 * Copyright 1998 Arizona Board of Regents, on behalf of
 *         The University of Arizona
 *         All Rights Reserved
 *
 *
 *                        Copyright (c) 1987 Bellcore
 *                            All Rights Reserved
 *       Permission is granted to copy or use this program, EXCEPT that it
 *       may not be sold for profit, the copyright notice must be reproduced
 *       on copies, and credit should be given to Bellcore where it is due.
 *       BELLCORE MAKES NO WARRANTY AND ACCEPTS NO LIABILITY FOR THIS PROGRAM.
 *
 * @COPYRIGHT@
 *
 * $\RCSfile: bit_destroy.c,v $
 *
 * HISTORY
 * $\Log: bit_destroy.c,v $
 * Revision 1.3  1998/01/31 18:43:02  mjk
 * replaced copyright
 *
 * Revision 1.2  1998/01/28 18:23:56  mjk
 * copyright
 *
 * Revision 1.1  1997/04/15 18:15:49  acb
 * Initial revision
 *
 * Revision 1.1  1997/03/25 22:19:39  acb
 * Initial revision
 *
 * Revision 1.1  1997/03/12 18:01:14  acb
 * Initial revision
 *
 * Revision 1.2  1996/12/19  21:12:41  acb
 * * Eliminated most global variables
 * * Rlogin windows can be created from menu
 * * 'Destroy window' and 'quit' menu options work now
 * * Moved location of header files
 * * Many small display glitches fixed
 *
 * Revision 1.1  1996/10/22 23:53:34  abhiram
 * Initial revision
 *
 */


/*{{{}}}*/
/*{{{  #includes*/
#include <share.h>
#include <stdlib.h>
#include <screen.h>
#include <bitblit.h>

/*}}}  */

/*{{{  bit_destroy -- destroy a bitmap, free up space*/
void bit_destroy(bitmap) BITMAP *bitmap;
{
  if (bitmap==(BITMAP*)0) return;

  /* destroy bitmap cache for primary bitmaps */
  if (IS_PRIMARY(bitmap) && bitmap->cache)
  {
    bit_destroy(bitmap->cache);
    bitmap->cache=NULL;
  }

  if (IS_MEMORY(bitmap) && IS_PRIMARY(bitmap))
  {
    free(bitmap->data);
    bitmap->data=(DATA*)0;
  }

  /* dont free static bitmaps */
  if (IS_STATIC(bitmap) && IS_PRIMARY(bitmap)) return;

  free(bitmap);
}
